Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1470)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1477)
@@ -1478,109 +1402,95 @@
 	    call writediagfi(ngrid,"mass_evap","mass gain"," ",3,zdmassmr)
 	    call writediagfi(ngrid,"mass_evap_col","mass gain col"," ",2,zdmassmr_col)
-	    call writediagfi(ngrid,"mass","mass"," ",3,mass)
-
-	    call mass_redistribution(ngrid,nlayer,nq,ptimestep,   &
-                       rnat,capcal,pplay,pplev,pt,tsurf,pq,qsurf,     &
-		       pu,pv,pdt,zdtsurf,pdq,pdu,pdv,zdmassmr,  &
-		       zdtmr,zdtsurfmr,zdpsrfmr,zdumr,zdvmr,zdqmr,zdqsurfmr)
+	    call writediagfi(ngrid,"mass","mass","kg/m2",3,mass)
+
+	    call mass_redistribution(ngrid,nlayer,nq,ptimestep,                     &
+                                     rnat,capcal,pplay,pplev,pt,tsurf,pq,qsurf,     &
+		                     pu,pv,pdt,zdtsurf,pdq,pdu,pdv,zdmassmr,        &
+		                     zdtmr,zdtsurfmr,zdpsrfmr,zdumr,zdvmr,zdqmr,zdqsurfmr)
 	 
-
             pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqmr(1:ngrid,1:nlayer,1:nq)
-            dqsurf(1:ngrid,1:nq)         = dqsurf(1:ngrid,1:nq) + zdqsurfmr(1:ngrid,1:nq)
-            pdt(1:ngrid,1:nlayer)        = pdt(1:ngrid,1:nlayer) + zdtmr(1:ngrid,1:nlayer)
-            pdu(1:ngrid,1:nlayer)        = pdu(1:ngrid,1:nlayer) + zdumr(1:ngrid,1:nlayer)
-            pdv(1:ngrid,1:nlayer)        = pdv(1:ngrid,1:nlayer) + zdvmr(1:ngrid,1:nlayer)
-	    pdpsrf(1:ngrid)                = pdpsrf(1:ngrid) + zdpsrfmr(1:ngrid)
-            zdtsurf(1:ngrid)               = zdtsurf(1:ngrid) + zdtsurfmr(1:ngrid)
+            dqsurf(1:ngrid,1:nq)       = dqsurf(1:ngrid,1:nq) + zdqsurfmr(1:ngrid,1:nq)
+            pdt(1:ngrid,1:nlayer)      = pdt(1:ngrid,1:nlayer) + zdtmr(1:ngrid,1:nlayer)
+            pdu(1:ngrid,1:nlayer)      = pdu(1:ngrid,1:nlayer) + zdumr(1:ngrid,1:nlayer)
+            pdv(1:ngrid,1:nlayer)      = pdv(1:ngrid,1:nlayer) + zdvmr(1:ngrid,1:nlayer)
+	    pdpsrf(1:ngrid)            = pdpsrf(1:ngrid) + zdpsrfmr(1:ngrid)
+            zdtsurf(1:ngrid)           = zdtsurf(1:ngrid) + zdtsurfmr(1:ngrid)
 	    
-!	    print*,'after mass redistrib, q=',pq(211,1:nlayer,igcm_h2o_vap)+ptimestep*pdq(211,1:nlayer,igcm_h2o_vap) 
 	 endif
 
-
-!   7e. Ocean
-!     ---------
-
-!       ---------------------------------
-!       Slab_ocean
-!       ---------------------------------
-      if (ok_slab_ocean)then
-
-         do ig=1,ngrid
-            qsurfint(:,igcm_h2o_ice)=qsurf(:,igcm_h2o_ice)
-         enddo
-
-         call ocean_slab_ice(ptimestep, &
-               ngrid, knindex, tsea_ice, fluxrad, &
-               zdqssnow, qsurf(:,igcm_h2o_ice), &
-               -zdqsdif(:,igcm_h2o_vap), &
-               flux_sens_lat,tsea_ice, pctsrf_sic, &
-               taux,tauy,icount)
-
-
-         call ocean_slab_get_vars(ngrid,tslab, &
-               sea_ice, flux_o, &
-               flux_g, dt_hdiff, &
-               dt_ekman)
-
+  ! ------------------
+  !   VI.4. Slab Ocean
+  ! ------------------
+
+         if (ok_slab_ocean)then
+
+            do ig=1,ngrid
+               qsurfint(:,igcm_h2o_ice)=qsurf(:,igcm_h2o_ice)
+            enddo
+
+            call ocean_slab_ice(ptimestep,                          &
+                                ngrid, knindex, tsea_ice, fluxrad,  &
+                                zdqssnow, qsurf(:,igcm_h2o_ice),    &
+                              - zdqsdif(:,igcm_h2o_vap),            &
+                                flux_sens_lat,tsea_ice, pctsrf_sic, &
+                                taux,tauy,icount)
+
+
+            call ocean_slab_get_vars(ngrid,tslab,      &
+                                     sea_ice, flux_o,  &
+                                     flux_g, dt_hdiff, &
+                                     dt_ekman)
+   
             do ig=1,ngrid
                if (nint(rnat(ig)).eq.1)then
-               tslab(ig,1) = 0.
-               tslab(ig,2) = 0.
-               tsea_ice(ig) = 0.
-               sea_ice(ig) = 0.
-               pctsrf_sic(ig) = 0.
-               qsurf(ig,igcm_h2o_ice)=qsurfint(ig,igcm_h2o_ice)
+                  tslab(ig,1) = 0.
+                  tslab(ig,2) = 0.
+                  tsea_ice(ig) = 0.
+                  sea_ice(ig) = 0.
+                  pctsrf_sic(ig) = 0.
+                  qsurf(ig,igcm_h2o_ice) = qsurfint(ig,igcm_h2o_ice)
                endif
             enddo
 
-
-      endif! (ok_slab_ocean)
-
-!       ---------------------------------
-!       Updating tracer budget on surface
-!       ---------------------------------
+         endif ! end of 'ok_slab_ocean'
+
+  ! -----------------------------
+  !   VI.5. Surface Tracer Update
+  ! -----------------------------
 
          if(hydrology)then
             
-            call hydrol(ngrid,nq,ptimestep,rnat,tsurf,qsurf,dqsurf,dqs_hyd,    &
-               capcal,albedo0,albedo,mu0,zdtsurf,zdtsurf_hyd,hice,pctsrf_sic,  &
-               sea_ice)
-            ! note: for now, also changes albedo in the subroutine
-
-            zdtsurf(1:ngrid) = zdtsurf(1:ngrid) + zdtsurf_hyd(1:ngrid)
+            call hydrol(ngrid,nq,ptimestep,rnat,tsurf,qsurf,dqsurf,dqs_hyd,             &
+                        capcal,albedo0,albedo,mu0,zdtsurf,zdtsurf_hyd,hice,pctsrf_sic,  &
+                        sea_ice)
+
+            zdtsurf(1:ngrid)    = zdtsurf(1:ngrid) + zdtsurf_hyd(1:ngrid)
             qsurf(1:ngrid,1:nq) = qsurf(1:ngrid,1:nq) + ptimestep*dqs_hyd(1:ngrid,1:nq)
-            ! when hydrology is used, other dqsurf tendencies are all added to dqs_hyd inside
-
-            !-------------------------
-            ! test energy conservation
+
+            ! Test energy conservation
             if(enertest)then
 	       call planetwide_sumval(area(:)*capcal(:)*zdtsurf_hyd(:)/totarea_planet,dEtots)
 	       if (is_master) print*,'In hydrol surface energy change     =',dEtots,' W m-2'
             endif
-            !-------------------------
-
-            !-------------------------
+
             ! test water conservation
             if(watertest)then
 	       call planetwide_sumval(dqs_hyd(:,igcm_h2o_ice)*area(:)*ptimestep/totarea_planet,dWtots)
 	       if (is_master) print*,'In hydrol surface ice change            =',dWtots,' kg m-2'
-	       call planetwide_sumval(dqs_hyd(:,igcm_h2o_vap)*area(:)*ptimestep/totarea_planet,dWtots)
+	          call planetwide_sumval(dqs_hyd(:,igcm_h2o_vap)*area(:)*ptimestep/totarea_planet,dWtots)
 	       if (is_master) then
-               	print*,'In hydrol surface water change          =',dWtots,' kg m-2'
-               	print*,'---------------------------------------------------------------'
+                  print*,'In hydrol surface water change          =',dWtots,' kg m-2'
+                  print*,'---------------------------------------------------------------'
 	       endif
             endif
-            !-------------------------
-
-         ELSE     ! of if (hydrology)
+
+         else ! of if (hydrology)
 
             qsurf(1:ngrid,1:nq)=qsurf(1:ngrid,1:nq)+ptimestep*dqsurf(1:ngrid,1:nq)
 
-         END IF   ! of if (hydrology)
-
-         ! Add qsurf to qsurf_hist, which is what we save in
-         ! diagfi.nc etc. At the same time, we set the water 
-         ! content of ocean gridpoints back to zero, in order
-         ! to avoid rounding errors in vdifc, rain
+         end if ! of if (hydrology)
+
+         ! Add qsurf to qsurf_hist, which is what we save in diagfi.nc. At the same time, we set the water 
+         ! content of ocean gridpoints back to zero, in order to avoid rounding errors in vdifc, rain.
          qsurf_hist(:,:) = qsurf(:,:)
 
@@ -1589,12 +1499,13 @@
          endif
 
-      endif   !  of if (tracer) 
-
-!-----------------------------------------------------------------------
-!   9. Surface and sub-surface soil temperature
-!-----------------------------------------------------------------------
-
-!     Increment surface temperature
-
+      endif! end of if 'tracer'
+
+
+!------------------------------------------------
+!   VII. Surface and sub-surface soil temperature 
+!------------------------------------------------
+
+
+      ! Increment surface temperature
       if(ok_slab_ocean)then
          do ig=1,ngrid
@@ -1608,56 +1519,60 @@
       else
         tsurf(1:ngrid)=tsurf(1:ngrid)+ptimestep*zdtsurf(1:ngrid) 
-      endif!(ok_slab_ocean)
-
-!     Compute soil temperatures and subsurface heat flux
+      endif ! end of 'ok_slab_ocean'
+
+
+      ! Compute soil temperatures and subsurface heat flux.
       if (callsoil) then
          call soil(ngrid,nsoilmx,.false.,lastcall,inertiedat,   &
-                ptimestep,tsurf,tsoil,capcal,fluxgrd)     
+                   ptimestep,tsurf,tsoil,capcal,fluxgrd)     
       endif
 
 
       if (ok_slab_ocean) then
-            do ig=1,ngrid
-               fluxgrdocean(ig)=fluxgrd(ig)
-               if (nint(rnat(ig)).eq.0) then
+      
+         do ig=1,ngrid
+         
+            fluxgrdocean(ig)=fluxgrd(ig)
+            if (nint(rnat(ig)).eq.0) then
                capcal(ig)=capcalocean
                fluxgrd(ig)=0.
                fluxgrdocean(ig)=pctsrf_sic(ig)*flux_g(ig)+(1-pctsrf_sic(ig))*(dt_hdiff(ig,1)+dt_ekman(ig,1))
-                 do iq=1,nsoilmx
-                    tsoil(ig,iq)=tsurf(ig)
-                 enddo
-                 if (pctsrf_sic(ig).gt.0.5) then
-                   capcal(ig)=capcalseaice
-                   if (qsurf(ig,igcm_h2o_ice).gt.0.) then
-                   capcal(ig)=capcalsno
-                   endif
-                 endif
-               endif
-            enddo
-      endif !(ok_slab_ocean)
-
-!-------------------------
-! test energy conservation
+               do iq=1,nsoilmx
+                  tsoil(ig,iq)=tsurf(ig)
+               enddo
+               if (pctsrf_sic(ig).gt.0.5) then
+                  capcal(ig)=capcalseaice
+                  if (qsurf(ig,igcm_h2o_ice).gt.0.) then
+                     capcal(ig)=capcalsno
+                  endif
+               endif               
+            endif
+            
+         enddo
+         
+      endif !end of 'ok_slab_ocean'
+
+
+      ! Test energy conservation
       if(enertest)then
 	 call planetwide_sumval(area(:)*capcal(:)*zdtsurf(:)/totarea_planet,dEtots)	 
 	 if (is_master) print*,'Surface energy change                 =',dEtots,' W m-2'
       endif
-!-------------------------
-
-!-----------------------------------------------------------------------
-!  10. Perform diagnostics and write output files
-!-----------------------------------------------------------------------
-
-!    -------------------------------
-!    Dynamical fields incrementation
-!    -------------------------------
-!    For output only: the actual model integration is performed in the dynamics
+
+
+!---------------------------------------------------
+!   VIII. Perform diagnostics and write output files
+!---------------------------------------------------
+
+      ! Note : For output only: the actual model integration is performed in the dynamics.
+
+
  
-      ! temperature, zonal and meridional wind
+      ! Temperature, zonal and meridional winds.
       zt(1:ngrid,1:nlayer) = pt(1:ngrid,1:nlayer) + pdt(1:ngrid,1:nlayer)*ptimestep
       zu(1:ngrid,1:nlayer) = pu(1:ngrid,1:nlayer) + pdu(1:ngrid,1:nlayer)*ptimestep
       zv(1:ngrid,1:nlayer) = pv(1:ngrid,1:nlayer) + pdv(1:ngrid,1:nlayer)*ptimestep
 
-      ! diagnostic
+      ! Diagnostic.
       zdtdyn(1:ngrid,1:nlayer)     = pt(1:ngrid,1:nlayer)-ztprevious(1:ngrid,1:nlayer)
       ztprevious(1:ngrid,1:nlayer) = zt(1:ngrid,1:nlayer)
@@ -1667,25 +1582,18 @@
       endif
 
-      ! dynamical heating diagnostic
+      ! Dynamical heating diagnostic.
       do ig=1,ngrid
          fluxdyn(ig)= SUM(zdtdyn(ig,:) *mass(ig,:))*cpp/ptimestep
       enddo
 
-      ! tracers
+      ! Tracers.
       zq(1:ngrid,1:nlayer,1:nq) = pq(1:ngrid,1:nlayer,1:nq) + pdq(1:ngrid,1:nlayer,1:nq)*ptimestep
 
-      ! surface pressure
+      ! Surface pressure.
       ps(1:ngrid) = pplev(1:ngrid,1) + pdpsrf(1:ngrid)*ptimestep
 
-      ! pressure
-      do l=1,nlayer
-          zplev(1:ngrid,l) = pplev(1:ngrid,l)/pplev(1:ngrid,1)*ps(:)
-          zplay(1:ngrid,l) = pplay(1:ngrid,l)/pplev(1:ngrid,1)*ps(1:ngrid)
-      enddo
-
-!     ---------------------------------------------------------
-!     Surface and soil temperature information
-!     ---------------------------------------------------------
-
+
+
+      ! Surface and soil temperature information
       call planetwide_sumval(area(:)*tsurf(:)/totarea_planet,Ts1)
       call planetwide_minval(tsurf(:),Ts2)
@@ -1693,17 +1601,15 @@
       if(callsoil)then
          TsS = SUM(area(:)*tsoil(:,nsoilmx))/totarea        ! mean temperature at bottom soil layer
-           print*,'  ave[Tsurf]     min[Tsurf]     max[Tsurf]     ave[Tdeep]'
-           print*,Ts1,Ts2,Ts3,TsS
+         print*,'  ave[Tsurf]     min[Tsurf]     max[Tsurf]     ave[Tdeep]'
+         print*,Ts1,Ts2,Ts3,TsS
       else
-      	if (is_master) then
-           print*,'  ave[Tsurf]     min[Tsurf]     max[Tsurf]'
-           print*,Ts1,Ts2,Ts3
-	endif
+      	 if (is_master) then
+            print*,'  ave[Tsurf]     min[Tsurf]     max[Tsurf]'
+            print*,Ts1,Ts2,Ts3
+	 endif
       end if
 
-!     ---------------------------------------------------------
-!     Check the energy balance of the simulation during the run
-!     ---------------------------------------------------------
-
+
+      ! Check the energy balance of the simulation during the run
       if(corrk)then
 
@@ -1730,6 +1636,6 @@
 	 
 	 if (is_master) then
-         	print*,'  ISR            ASR            OLR            GND            DYN [W m^-2]'
-         	print*, ISR,ASR,OLR,GND,DYN
+            print*,'  ISR            ASR            OLR            GND            DYN [W m^-2]'
+            print*, ISR,ASR,OLR,GND,DYN
 	 endif
 
@@ -1748,7 +1654,7 @@
                open(93,file="tem_bal.out",form='formatted',position='append')
                if(callsoil)then
-               	write(93,*) zday,Ts1,Ts2,Ts3,TsS
+               	  write(93,*) zday,Ts1,Ts2,Ts3,TsS
 	       else
-	        write(93,*) zday,Ts1,Ts2,Ts3
+	          write(93,*) zday,Ts1,Ts2,Ts3
 	       endif
                close(93)
@@ -1756,10 +1662,8 @@
          endif
 
-      endif
-
-
-!     ------------------------------------------------------------------
-!     Diagnostic to test radiative-convective timescales in code
-!     ------------------------------------------------------------------
+      endif ! end of 'corrk'
+
+
+      ! Diagnostic to test radiative-convective timescales in code.
       if(testradtimes)then
          open(38,file="tau_phys.out",form='formatted',position='append')
@@ -1774,16 +1678,15 @@
       endif
 
-!     ---------------------------------------------------------
-!     Compute column amounts (kg m-2) if tracers are enabled
-!     ---------------------------------------------------------
+
+      ! Compute column amounts (kg m-2) if tracers are enabled.
       if(tracer)then
          qcol(1:ngrid,1:nq)=0.0
          do iq=1,nq
-           do ig=1,ngrid
-              qcol(ig,iq) = SUM( zq(ig,1:nlayer,iq) * mass(ig,1:nlayer))
-           enddo
+            do ig=1,ngrid
+               qcol(ig,iq) = SUM( zq(ig,1:nlayer,iq) * mass(ig,1:nlayer))
+            enddo
          enddo
 
-         ! Generalised for arbitrary aerosols now. (LK)
+         ! Generalised for arbitrary aerosols now. By LK
          reffcol(1:ngrid,1:naerkind)=0.0
          if(co2cond.and.(iaero_co2.ne.0))then
@@ -1801,10 +1704,8 @@
          endif
 
-      endif
-
-!     ---------------------------------------------------------
-!     Test for water conservation if water is enabled
-!     ---------------------------------------------------------
-
+      endif ! end of 'tracer'
+
+
+      ! Test for water conservation.
       if(water)then
 
@@ -1817,7 +1718,7 @@
 	 
 	 if (is_master) then
-         	print*,' Total water amount [kg m^-2]: ',h2otot
-         	print*,' Surface ice    Surface liq.   Atmos. con.     Atmos. vap. [kg m^-2] '
-         	print*, icesrf,liqsrf,icecol,vapcol
+            print*,' Total water amount [kg m^-2]: ',h2otot
+            print*,' Surface ice    Surface liq.   Atmos. con.     Atmos. vap. [kg m^-2] '
+            print*, icesrf,liqsrf,icecol,vapcol
 	 endif
 
@@ -1833,9 +1734,8 @@
       endif
 
-!     ---------------------------------------------------------
-!     Calculate RH for diagnostic if water is enabled
-!     ---------------------------------------------------------
-
+
+      ! Calculate RH (Relative Humidity) for diagnostic.
       if(water)then
+      
          do l = 1, nlayer
             do ig=1,ngrid
@@ -1845,16 +1745,19 @@
          enddo
 
-         ! compute maximum possible H2O column amount (100% saturation)
+         ! Compute maximum possible H2O column amount (100% saturation).
          do ig=1,ngrid
-               H2Omaxcol(ig) = SUM( qsat(ig,:) * mass(ig,:))
+            H2Omaxcol(ig) = SUM( qsat(ig,:) * mass(ig,:))
          enddo
 
-      endif
-
-
-           print*,'--> Ls =',zls*180./pi
-!        -------------------------------------------------------------------
+      endif ! end of 'water'
+
+
+      print*,'--> Ls =',zls*180./pi
+      
+      
+!----------------------------------------------------------------------
 !        Writing NetCDF file  "RESTARTFI" at the end of the run
-!        -------------------------------------------------------------------
+!----------------------------------------------------------------------
+
 !        Note: 'restartfi' is stored just before dynamics are stored
 !              in 'restart'. Between now and the writting of 'restart',
@@ -1863,132 +1766,126 @@
 !              thus we store for time=time+dtvr
 
-         if(lastcall) then
-            ztime_fin = ptime + ptimestep/(float(iphysiq)*daysec)
-
-
-!           Update surface ice distribution to iterate to steady state if requested
-            if(ice_update)then
-
-               do ig=1,ngrid
-
-                  delta_ice = (qsurf(ig,igcm_h2o_ice)-ice_initial(ig))
-
-                  ! add multiple years of evolution
-                  qsurf_hist(ig,igcm_h2o_ice) = qsurf_hist(ig,igcm_h2o_ice) + delta_ice*icetstep 
-
-                  ! if ice has gone -ve, set to zero
-                  if(qsurf_hist(ig,igcm_h2o_ice).lt.0.0)then
-                     qsurf_hist(ig,igcm_h2o_ice) = 0.0 
-                  endif
-
-                  ! if ice is seasonal, set to zero (NEW)
-                  if(ice_min(ig).lt.0.01)then
-                     qsurf_hist(ig,igcm_h2o_ice) = 0.0 
-                  endif
-
-               enddo
-
-               ! enforce ice conservation
-               ice_tot= SUM(qsurf_hist(:,igcm_h2o_ice)*area(:) )
-               qsurf_hist(:,igcm_h2o_ice) = qsurf_hist(:,igcm_h2o_ice)*(icesrf/ice_tot)
-
-            endif
-
-            if (ngrid.ne.1) then
-              write(*,*)'PHYSIQ: for physdem ztime_fin =',ztime_fin
-!#ifdef CPP_PARA
-!! for now in parallel we use a different routine to write restartfi.nc
-!            call phyredem(ngrid,"restartfi.nc",           &
-!                    ptimestep,pday,ztime_fin,tsurf,tsoil,emis,q2,qsurf_hist, &
-!                    cloudfrac,totcloudfrac,hice)
-!#else
-!            call physdem1(ngrid,"restartfi.nc",long,lati,nsoilmx,nq,            &
-!                    ptimestep,pday,ztime_fin,tsurf,tsoil,emis,q2,qsurf_hist, &
-!                    area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,      &
-!                    cloudfrac,totcloudfrac,hice,noms)
-!#endif
-              call physdem1("restartfi.nc",nsoilmx,ngrid,nlayer,nq, &
-                      ptimestep,ztime_fin, &
-                      tsurf,tsoil,emis,q2,qsurf_hist, &
-                      cloudfrac,totcloudfrac,hice, &
-                      rnat,pctsrf_sic,tslab,tsea_ice,sea_ice)
-            endif
-
-            if(ok_slab_ocean) then
-              call ocean_slab_final!(tslab, seaice)
-            end if
+
+
+      if(lastcall) then
+         ztime_fin = ptime + ptimestep/(float(iphysiq)*daysec)
+
+         ! Update surface ice distribution to iterate to steady state if requested
+         if(ice_update)then
+
+            do ig=1,ngrid
+
+               delta_ice = (qsurf(ig,igcm_h2o_ice)-ice_initial(ig))
+               
+               ! add multiple years of evolution
+               qsurf_hist(ig,igcm_h2o_ice) = qsurf_hist(ig,igcm_h2o_ice) + delta_ice*icetstep 
+
+               ! if ice has gone -ve, set to zero
+               if(qsurf_hist(ig,igcm_h2o_ice).lt.0.0)then
+                  qsurf_hist(ig,igcm_h2o_ice) = 0.0 
+               endif
+
+               ! if ice is seasonal, set to zero (NEW)
+               if(ice_min(ig).lt.0.01)then
+                  qsurf_hist(ig,igcm_h2o_ice) = 0.0 
+               endif
+
+            enddo
+
+            ! enforce ice conservation
+            ice_tot= SUM(qsurf_hist(:,igcm_h2o_ice)*area(:) )
+            qsurf_hist(:,igcm_h2o_ice) = qsurf_hist(:,igcm_h2o_ice)*(icesrf/ice_tot)
+
+         endif
+
+         if (ngrid.ne.1) then
+            write(*,*)'PHYSIQ: for physdem ztime_fin =',ztime_fin
+            
+            call physdem1("restartfi.nc",nsoilmx,ngrid,nlayer,nq, &
+                          ptimestep,ztime_fin,                    &
+                          tsurf,tsoil,emis,q2,qsurf_hist,         &
+                          cloudfrac,totcloudfrac,hice,            &
+                          rnat,pctsrf_sic,tslab,tsea_ice,sea_ice)
+         endif
+
+         if(ok_slab_ocean) then
+            call ocean_slab_final!(tslab, seaice)
+         end if
 
          
-         endif ! of if (lastcall)
-
-
-!        -----------------------------------------------------------------
+      endif ! end of 'lastcall'
+
+
+!-----------------------------------
 !        Saving statistics :
-!        -----------------------------------------------------------------
-!        ("stats" stores and accumulates 8 key variables in file "stats.nc"
-!        which can later be used to make the statistic files of the run:
-!        "stats")          only possible in 3D runs !
+!-----------------------------------
+
+!    Note :("stats" stores and accumulates 8 key variables in file "stats.nc"
+!           which can later be used to make the statistic files of the run:
+!           "stats")          only possible in 3D runs !!!
 
          
-         if (callstats) then
-
-            call wstats(ngrid,"ps","Surface pressure","Pa",2,ps)
-            call wstats(ngrid,"tsurf","Surface temperature","K",2,tsurf)
-            call wstats(ngrid,"fluxsurf_lw",                               &
-                        "Thermal IR radiative flux to surface","W.m-2",2,  &
-                         fluxsurf_lw)
+      if (callstats) then
+
+         call wstats(ngrid,"ps","Surface pressure","Pa",2,ps)
+         call wstats(ngrid,"tsurf","Surface temperature","K",2,tsurf)
+         call wstats(ngrid,"fluxsurf_lw",                               &
+                     "Thermal IR radiative flux to surface","W.m-2",2,  &
+                     fluxsurf_lw)
+         call wstats(ngrid,"fluxtop_lw",                                &
+                     "Thermal IR radiative flux to space","W.m-2",2,    &
+                     fluxtop_lw)
+                     
 !            call wstats(ngrid,"fluxsurf_sw",                               &
 !                        "Solar radiative flux to surface","W.m-2",2,       &
-!                         fluxsurf_sw_tot)
-            call wstats(ngrid,"fluxtop_lw",                                &
-                        "Thermal IR radiative flux to space","W.m-2",2,    &
-                        fluxtop_lw)
+!                         fluxsurf_sw_tot)                     
 !            call wstats(ngrid,"fluxtop_sw",                                &
 !                        "Solar radiative flux to space","W.m-2",2,         &
 !                        fluxtop_sw_tot)
 
-            call wstats(ngrid,"ISR","incoming stellar rad.","W m-2",2,fluxtop_dn)
-            call wstats(ngrid,"ASR","absorbed stellar rad.","W m-2",2,fluxabs_sw)
-            call wstats(ngrid,"OLR","outgoing longwave rad.","W m-2",2,fluxtop_lw)
-            call wstats(ngrid,"ALB","Surface albedo"," ",2,albedo)
-            call wstats(ngrid,"p","Pressure","Pa",3,pplay)
-            call wstats(ngrid,"temp","Atmospheric temperature","K",3,zt)
-            call wstats(ngrid,"u","Zonal (East-West) wind","m.s-1",3,zu)
-            call wstats(ngrid,"v","Meridional (North-South) wind","m.s-1",3,zv)
-            call wstats(ngrid,"w","Vertical (down-up) wind","m.s-1",3,pw)
-            call wstats(ngrid,"q2","Boundary layer eddy kinetic energy","m2.s-2",3,q2)
-
-           if (tracer) then
-             do iq=1,nq
-                call wstats(ngrid,noms(iq),noms(iq),'kg/kg',3,zq(1,1,iq))
-                call wstats(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
-                          'kg m^-2',2,qsurf(1,iq) )
-
-                call wstats(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
+
+         call wstats(ngrid,"ISR","incoming stellar rad.","W m-2",2,fluxtop_dn)
+         call wstats(ngrid,"ASR","absorbed stellar rad.","W m-2",2,fluxabs_sw)
+         call wstats(ngrid,"OLR","outgoing longwave rad.","W m-2",2,fluxtop_lw)
+         call wstats(ngrid,"ALB","Surface albedo"," ",2,albedo)
+         call wstats(ngrid,"p","Pressure","Pa",3,pplay)
+         call wstats(ngrid,"temp","Atmospheric temperature","K",3,zt)
+         call wstats(ngrid,"u","Zonal (East-West) wind","m.s-1",3,zu)
+         call wstats(ngrid,"v","Meridional (North-South) wind","m.s-1",3,zv)
+         call wstats(ngrid,"w","Vertical (down-up) wind","m.s-1",3,pw)
+         call wstats(ngrid,"q2","Boundary layer eddy kinetic energy","m2.s-2",3,q2)
+
+         if (tracer) then
+            do iq=1,nq
+               call wstats(ngrid,noms(iq),noms(iq),'kg/kg',3,zq(1,1,iq))
+               call wstats(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
+                           'kg m^-2',2,qsurf(1,iq) )
+               call wstats(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
                           'kg m^-2',2,qcol(1,iq) )
-!                call wstats(ngrid,trim(noms(iq))//'_reff',                          & 
+                          
+!              call wstats(ngrid,trim(noms(iq))//'_reff',                          & 
 !                          trim(noms(iq))//'_reff',                                   & 
 !                          'm',3,reffrad(1,1,iq))
-              end do
+
+            end do
+            
             if (water) then
                vmr=zq(1:ngrid,1:nlayer,igcm_h2o_vap)*mugaz/mmol(igcm_h2o_vap)
-               call wstats(ngrid,"vmr_h2ovapor",                           &
-                          "H2O vapour volume mixing ratio","mol/mol",       & 
-                          3,vmr)
-            endif ! of if (water)
-
-           endif !tracer 
-
-          if(watercond.and.CLFvarying)then
-             call wstats(ngrid,"rneb_man","H2O cloud fraction (conv)"," ",3,rneb_man)
-             call wstats(ngrid,"rneb_lsc","H2O cloud fraction (large scale)"," ",3,rneb_lsc)
-             call wstats(ngrid,"CLF","H2O cloud fraction"," ",3,cloudfrac)
-             call wstats(ngrid,"CLFt","H2O column cloud fraction"," ",2,totcloudfrac)
-             call wstats(ngrid,"RH","relative humidity"," ",3,RH)
-          endif
-
-
-
-           if (ok_slab_ocean) then
+               call wstats(ngrid,"vmr_h2ovapor",                             &
+                           "H2O vapour volume mixing ratio","mol/mol",       & 
+                           3,vmr)
+            endif
+
+         endif ! end of 'tracer' 
+
+         if(watercond.and.CLFvarying)then
+            call wstats(ngrid,"rneb_man","H2O cloud fraction (conv)"," ",3,rneb_man)
+            call wstats(ngrid,"rneb_lsc","H2O cloud fraction (large scale)"," ",3,rneb_lsc)
+            call wstats(ngrid,"CLF","H2O cloud fraction"," ",3,cloudfrac)
+            call wstats(ngrid,"CLFt","H2O column cloud fraction"," ",2,totcloudfrac)
+            call wstats(ngrid,"RH","relative humidity"," ",3,RH)
+         endif
+
+         if (ok_slab_ocean) then
             call wstats(ngrid,"dt_hdiff1","dt_hdiff1","K/s",2,dt_hdiff(:,1))
             call wstats(ngrid,"dt_hdiff2","dt_hdiff2","K/s",2,dt_hdiff(:,2))
